//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
 PortIndex = LPT1;
 vamp = new CVampLpt(); //      LPTVAMPIR.sys
 Panel1->Color = (vamp->Ready())?clLime:clRed;
 ContinuePoll = true;   //   
 //   
 ULONG id;
 PollThread = CreateThread(NULL,0,(PTHREAD_START_ROUTINE)PollThreadProc,this,0,&id);
 SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 CloseHandle(PollThread);
 delete vamp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
 //   
 ULONG PortIndex = LPT1;
 PORT_DATA pd;

 ComboBox1->Items->Clear(); // !
 ListBox1->Items->Clear();
 ComboBox1->Text = "";

 while (PortIndex<=LPT2)
 { //    
  if (vamp->GetPortMode(PortIndex,&pd)) //   
  {
   if (pd.PortPresent)
   { //   --  
    ComboBox1->Items->Add(AnsiString("LPT")+IntToStr(PortIndex));
   };
  };
  ++PortIndex;
 };

 if (ComboBox1->Items->Count!=0)
 { //   
  ComboBox1->ItemIndex = 0;
  ComboBox1Change(this);
 };

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ComboBox -- user  
 CheckBox1->Checked = false;
 CheckBox1Click(this);
 ListBox1->Items->Clear();
 AnsiString st = ComboBox1->Text;
 if (st.Length()<4) { return; };
 st = st.SubString(4,1);
 PortIndex = StrToInt(st); //    

 PORT_DATA pd; //      
 if (vamp->GetPortMode(PortIndex,&pd)) //   
 {
  if (pd.PortPresent)
  { //   --   
   // ---
   ListBox1->Items->Add(AnsiString(" ")+ComboBox1->Text);
   ListBox1->Items->Add("-----------------------------------------");
   ListBox1->Items->Add(AnsiString("  0x")+IntToHex((int)pd.BaseAddress,8));
   ListBox1->Items->Add(AnsiString("  : ")+IntToHex((int)pd.BaseAddressSpan,1));
   ListBox1->Items->Add(AnsiString(pd.CanUseInterrupt?"   ":"    "));
   ListBox1->Items->Add("-----------------------------------------");

   if (pd.EcpBase&&pd.EcpSpan)
   { //   ECP
    ListBox1->Items->Add(AnsiString("   ECP: 0x")+IntToHex((int)pd.EcpBase,8));
    ListBox1->Items->Add(AnsiString("  ECP: ")+IntToHex((int)pd.EcpSpan,1));
    ListBox1->Items->Add("-----------------------------------------");
   };
   // ---
  };
 };

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{ // 
 if (vamp->LockPort(PortIndex))
 {
  ListBox1->Items->Add(" ");
 } else
 {
  ListBox1->Items->Add(AnsiString(" ")+IntToStr(GetLastError())+AnsiString("   "));
 };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{ // 
 if (vamp->UnlockPort(PortIndex))
 {
  ListBox1->Items->Add(" ");
 } else
 {
  ListBox1->Items->Add(AnsiString(" ")+IntToStr(GetLastError())+AnsiString("   "));
 };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{ //   LPTx:
 HANDLE hlpt = vamp->OpenParPort(PortIndex);
 if (hlpt!=INVALID_HANDLE_VALUE)
 {
  ListBox1->Items->Add("    RAW   !");
 } else
 {
  ListBox1->Items->Add(AnsiString("!   = ")+IntToStr(GetLastError()));
 };
 CloseHandle(hlpt);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{ // /. 
 Timer1->Enabled = CheckBox1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ //  
 ADS ads[3] = { {DATA_OFFSET|ADS_READ,0xFF},
                {DSR_OFFSET |ADS_READ,0xFF},
                {DCR_OFFSET |ADS_READ,0xFF}};

 vamp->ReadWrite(PortIndex,ads,ads,3);

 Panel2->Caption = AnsiString("0 DATA: ") + IntToHex((int)ads[0].Data,2);
 Panel3->Caption = AnsiString("1 STAT: ") + IntToHex((int)ads[1].Data,2);
 Panel4->Caption = AnsiString("2 CNTR: ") + IntToHex((int)ads[2].Data,2);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{ //   
 BOOL enable = CheckBox2->Checked;
 if (vamp->EnableInterrupt(PortIndex,enable))
 {
  ListBox1->Items->Add(enable?"  ":"  ");
 } else
 {
  ListBox1->Items->Add("    .");
 };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ //
 if (((Key>='0')&&(Key<='9'))||((Key>='A')&&(Key<='F'))||((Key>='a')&&(Key<='f'))||(Key==8)||(Key==9))
 { return; };
 Key==0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1Enter(TObject *Sender)
{
 ((TEdit *)Sender)->SelectAll();       
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{ // output
 try
 {
  UCHAR data = StrToInt(AnsiString("0x")+Edit2->Text);
  ULONG offset = StrToInt(AnsiString("0x")+Edit1->Text);
  vamp->WriteRegister(PortIndex,offset,data);
 } catch (Exception &ex)
 {
 };
}
//---------------------------------------------------------------------------

//      
DWORD WINAPI PollThreadProc(PVOID Context)
{
 TForm1* MainForm = (TForm1 *)Context;
 MainForm->PollProc();
 return 0;
};
//---------------------------------------------------------------------------

//    
void TForm1::PollProc(void)
{
 while (ContinuePoll)
 { //     , 
  if (vamp->WaitForInterrupt(PortIndex,200))
  { //  
   OutputDebugString("TEST - INTERRUPT!!!");
   ++ctint;
   if (ctint>3)
   {
    ctint = 3;
   };
  };
 };
};

//
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{ //
 ContinuePoll = FALSE; //
 CanClose = (WAIT_OBJECT_0==WaitForSingleObject(PollThread,1000));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
 if (ctint==0)
 {
  Panel5->Color = clBtnFace;
 } else
 {
  Panel5->Color = clYellow;
  --ctint;
 };
}
//---------------------------------------------------------------------------

