//---------------------------------------------------------------------------
//
// VampLpt - UserMode     LPTVAMPIR
//
// :  .., http://progrex.narod.ru
//                     email: jstrap@yandex.ru
//
// : Freeware.
//
// : 25  2003 
//
//---------------------------------------------------------------------------

#ifndef VampLptH
#define VampLptH

#include <windows.h>
#include <winioctl.h>

//---------------------------------------------------------------------------

// --- 

//   
#define VAMPIRE_IOCTL_SIGNATURE 0x11101974

//   
#define VAMP_DRIVER_NAME "\\\\.\\LPTVAMPIRLINK0"

//   
#define VAMP_GET_PORT_DATA  1 //   
#define VAMP_LOCK_PORT      2 //  
#define VAMP_UNLOCK_PORT    3 //  
#define VAMP_USE_INTERRUPT  4 //  
#define VAMP_FREE_INTERRUPT 5 //  
#define VAMP_POLL_INTERRUPT 6 //   

//     
#define LPT1 1
#define LPT2 2
#define LPT3 3

//     
#define DATA_OFFSET         0 //    (DATA)
#define DSR_OFFSET          1 //   (DSR)
#define DCR_OFFSET          2 //   (DCR)
#define EPP_OFFSET          4 //  EPP

//     (DSR)
#define DSR_NOT_BUSY            0x80
#define DSR_NOT_ACK             0x40
#define DSR_PERROR              0x20
#define DSR_SELECT              0x10
#define DSR_NOT_FAULT           0x08

//     (DCR)
#define DCR_RESERVED            0xC0
#define DCR_DIRECTION           0x20
#define DCR_ACKINT_ENABLED      0x10
#define DCR_SELECT_IN           0x08
#define DCR_NOT_INIT            0x04
#define DCR_AUTOFEED            0x02
#define DCR_STROBE              0x01

//      Adr  ADS.
#define ADS_PAUSE       0x40 //  .  Data      .
#define ADS_READ        0x80 //  .  Data   ,   .
#define ADS_OFFSET_MASK 0x0F //      Adr  ADS

//    ADS,     IOCTL_VAMP_READ_WRITE_DATA
#define RW_REQ_MAX_ADS_COUNT 1024 //      :)


// ---    

//     
#define IOCTL_VAMP_CHECK           CTL_CODE(FILE_DEVICE_UNKNOWN, 0xC02, METHOD_BUFFERED, FILE_ANY_ACCESS)

//  
#define IOCTL_VAMP_CONTROL_REQUEST CTL_CODE(FILE_DEVICE_UNKNOWN, 0xC03, METHOD_BUFFERED, FILE_ANY_ACCESS)

//   /  /  
#define IOCTL_VAMP_READ_WRITE_DATA CTL_CODE(FILE_DEVICE_UNKNOWN, 0xC04, METHOD_BUFFERED, FILE_ANY_ACCESS)


// --- 

//     
typedef struct _PORT_CONTROL_REQUEST
{
 ULONG PortIndex;       //   0..2
 ULONG RequestCode;     //  
 union                  //  
 {
  ULONG Data[32];
 } u;
} PORT_CONTROL_REQUEST, *PPORT_CONTROL_REQUEST;

//     
typedef struct _PORT_DATA
{
 ULONG PortIndex;       //   0..2
 BOOL  PortPresent;     // TRUE -     
 ULONG BaseAddress;     //    .  0x278,0x378,0x3BE.
 ULONG BaseAddressSpan; //    
 ULONG EcpBase;         //    ECP. ==0,   ECP  .
 ULONG EcpSpan;         //   ECP
 ULONG HwCapabilities;  //     ECP
 ULONG CurrentMode;     //  
 BOOL  CanUseInterrupt; //    . TRUE -- .
} PORT_DATA, *PPORT_DATA;

//  /
typedef struct _ADS
{
 UCHAR Adr, Data; // +
} ADS, *PADS;

//     /
typedef struct _READ_WRITE_REQUEST
{
 ULONG PortIndex; //  
 ULONG PairCount; //   /
 ADS   Ads[0];    //  /
} READ_WRITE_REQUEST, *PREAD_WRITE_REQUEST;


// ---  (, .  .)

//    
class CVampLpt
{
 HANDLE hdrv;      //  
 HANDLE ev[LPT2];  //      

 public:
  CVampLpt(VOID);  // 
 ~CVampLpt(VOID);  // 

 //  .  TRUE,      .
 BOOL Ready(VOID);

 //      
 BOOL GetPortMode(ULONG PortIndex,           //  
                  PPORT_DATA pPortModeData); //   ,  

 //  
 BOOL LockPort(ULONG PortIndex);

 //  
 BOOL UnlockPort(ULONG PortIndex);
 
 // /  
 BOOL ReadWrite(ULONG PortIndex, //  
                PADS  Source,    //     ADS,    
                PADS  Dest,      //     ADS,     .
                ULONG PairCount);//   ADS   Source

 //   .  ,   .
 UCHAR ReadRegister(ULONG PortIndex, //  
                    ULONG RegOffset, //  
                    BOOL  *result);  // TRUE,    .  ==NULL,   .

 //    
 BOOL WriteRegister(ULONG PortIndex, //  
                    ULONG RegOffset, //  
                    UCHAR Data);     //     

 //     RAW-   
 HANDLE OpenParPort(ULONG PortIndex);

 // /  .
 BOOL EnableInterrupt(ULONG PortIndex, //  
                      BOOL Enable);    // TRUE -  

 //  .  TRUE,     .
 BOOL WaitForInterrupt(ULONG PortIndex, //  
                       ULONG MaxTime);  //   ,  .

 //      
 BOOL InterruptChReady(ULONG PortIndex);


};







//---------------------------------------------------------------------------
#endif
